AdminCaja/Areas/Admin/Controllers/FinantialController.cs
using AdminCaja.Areas.Admin.Models.Financial;
using AdminCaja.Areas.Admin.Services;
using AdminCaja.Models;
using AutoMapper;
using NPOI.SS.UserModel;
using NPOI.XSSF.Extractor;
using NPOI.XSSF.UserModel;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace AdminCaja.Areas.Admin.Controllers
{
    public class FinantialController : Controller
    {
        private ApplicationDbContext _context;
        private IMapper _mapper;
        private IFileService _fileService;

        public FinantialController(ApplicationDbContext context, IMapper mapper, IFileService fileService)
        {
            _context = context;
            _mapper = mapper;
            _fileService = fileService;
        }

        // GET: Admin/Finantial
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult EditFinantial(string lang = "es")
        {
            FinancialStatesModel financial = _context.FinancialStatesModels.FirstOrDefault(x => x.Language == lang && x.Tipo == FinancialStatesTypeEnum.Financial);
            var model = new FinancialViewModel { Language = lang, Tipo = FinancialStatesTypeEnum.Financial };

            if (financial != null)
            {
                model.Title = financial.Title;
            }

            return View(model);
        }

        [HttpPost]
        public async Task<ActionResult> SaveFinantial(FinancialViewModel model)
        {
            if (ModelState.IsValid)
            {
                await ImportExcelFinancial(model.FinancialData, model.Year, model.Month);

                FinancialStatesModel financial = await _context.FinancialStatesModels.FirstOrDefaultAsync(x => x.Language == model.Language && x.Tipo == FinancialStatesTypeEnum.Financial);

                if(financial == null)
                {
                    financial = new FinancialStatesModel {Language = model.Language, Tipo = FinancialStatesTypeEnum.Financial };
                    _context.FinancialStatesModels.Add(financial);
                }

                if (model.HeaderImage != null && model.HeaderImage.ContentLength > 0)
                {
                    if (!string.IsNullOrEmpty(financial.HeaderImage))
                        _fileService.DeleteImage(financial.HeaderImage);

                    financial.HeaderImage = _fileService.SaveFile(model.HeaderImage);
                }

                if (model.Balance != null && model.Balance.ContentLength > 0)
                {
                    if(financial.Balances != null)
                    {
                        var balanceExistente = financial.Balances.FirstOrDefault(x => x.Year == model.Year && x.Language == model.Language);
                        if(balanceExistente != null)
                        {
                            _fileService.DeleteImage(balanceExistente.Path);
                            financial.Balances.Remove(balanceExistente);
                        }
                    }

                    var balance = new FinancialBalance
                    {
                        Language = model.Language,
                        Year = model.Year,
                        Path = _fileService.SaveFile(model.HeaderImage),
                        FileName = model.Balance.FileName
                    };

                    financial.Balances.Add(balance);
                }

                financial.Title = model.Title;

                await _context.SaveChangesAsync();
            }
            return View("EditFinantial", model);
        }

        public ActionResult EditNumbers(string lang = "es")
        {
            FinancialStatesModel financial = _context.FinancialStatesModels.FirstOrDefault(x => x.Language == lang && x.Tipo == FinancialStatesTypeEnum.Numbers) ;
            var model = new NumbersViewModel { Language = lang, Tipo = FinancialStatesTypeEnum.Numbers };

            if (financial != null)
            {
                model.Title = financial.Title;
            }

            return View(model);
        }

        [HttpPost]
        public async Task<ActionResult> SaveNumbers(NumbersViewModel model)
        {
            if (model.SelectedPeriod.Length != 6)
            {
                ModelState.AddModelError("SelectedPeriod", "Debe seleccionar un período válido");
            }

            if (ModelState.IsValid)
            {

                int year = int.Parse(model.SelectedPeriod.Substring(0, 4));
                int quarter = int.Parse(model.SelectedPeriod.Substring(4, 2));

                await ImportExcelNumbers(model.FinancialData, year, quarter);

                FinancialStatesModel financial = await _context.FinancialStatesModels.FirstOrDefaultAsync(x => x.Language == model.Language && x.Tipo == FinancialStatesTypeEnum.Numbers);

                if (financial == null)
                {
                    financial = new FinancialStatesModel { Language = model.Language, Tipo = FinancialStatesTypeEnum.Numbers };
                    _context.FinancialStatesModels.Add(financial);
                }

                if (model.HeaderImage != null && model.HeaderImage.ContentLength > 0)
                {
                    if (!string.IsNullOrEmpty(financial.HeaderImage))
                        _fileService.DeleteImage(financial.HeaderImage);

                    financial.HeaderImage = _fileService.SaveFile(model.HeaderImage);
                }

                financial.Title = model.Title;

                await _context.SaveChangesAsync();
            }

            return View("EditNumbers", model);
        }

        #region Importador

        private async Task ImportExcelFinancial(HttpPostedFileBase financialData, int year, int month)
        {
            if(financialData != null && financialData.ContentLength > 0)
            {
                try
                {
                    XSSFWorkbook xls = new XSSFWorkbook(financialData.InputStream);

                    for (int i = 0; i < xls.NumberOfSheets; i++)
                    {
                        XSSFSheet sheet = xls.GetSheetAt(i) as XSSFSheet;
                        switch (sheet.SheetName)
                        {
                            case "EstadosFinancieros":
                                var financialStates = await ImportEstadosFinancieros(sheet, year);
                                break;

                            default:
                                break;
                        }
                    }
                }
                catch(Exception ex)
                {

                }
            }
        }

        private async Task ImportExcelNumbers(HttpPostedFileBase financialData, int year, int quarter)
        {
            if (financialData != null && financialData.ContentLength > 0)
            {
                try
                {
                    XSSFWorkbook xls = new XSSFWorkbook(financialData.InputStream);

                    for (int i = 0; i < xls.NumberOfSheets; i++)
                    {
                        XSSFSheet sheet = xls.GetSheetAt(i) as XSSFSheet;
                        switch (sheet.SheetName)
                        {
                            case "DatosRelevantes":
                                var datosRelevantes = await ImportarDatosRelevantes(sheet, year, quarter);
                                break;

                            case "ACRyP":
                                var acryp = await ImportarACRyP(sheet, year, quarter);
                                break;
                            case "ADC":
                                var adc = await ImportarAdc(sheet, year, quarter);
                                break;
                            case "ActivosEnCustodia":
                                var activosEnCustodia = await ImportarActivosEnCustodia(sheet, year, quarter);
                                break;
                            case "DepositoInternacional":
                                var deopositoInternacional = await ImportarDepositoInternacional(sheet, year, quarter);
                                break;
                            case "OtrosServicios":
                                var otros = await ImportarOtrosServicios(sheet, year, quarter);
                                break;
                            default:
                                break;
                        }
                    }
                }
                catch (Exception ex)
                {

                }
            }
        }

        private async Task<OtrosServicios> ImportarOtrosServicios(XSSFSheet sheet, int year, int quarter)
        {
            OtrosServicios data = await _context.OtrosServicios.FirstOrDefaultAsync(x => x.Year == year && x.Quarter == quarter);

            if(data == null) {     
                data = new OtrosServicios {
                    Year = year,
                    Quarter = quarter,
                    CPD = new OtrosServiciosData
                    {
                        CasaCentralPesos = new OtrosServiciosDataDetail(),
                        CasaCentralUs = new OtrosServiciosDataDetail(),
                        SucursalesPesos = new OtrosServiciosDataDetail(),
                        SucursalesUs = new OtrosServiciosDataDetail(),
                    }
,
                    PagareBursatil = new OtrosServiciosData
                    {
                        CasaCentralPesos = new OtrosServiciosDataDetail(),
                        CasaCentralUs = new OtrosServiciosDataDetail(),
                        SucursalesPesos = new OtrosServiciosDataDetail(),
                        SucursalesUs = new OtrosServiciosDataDetail(),
                    }
                };

                _context.OtrosServicios.Add(data);
            }

            IRow row;

AdminCaja/Areas/Admin/Views/Finantial/EditFinantial.cshtml
@using AdminCaja.Areas.Admin.Models.Financial
@using AdminCaja.Areas.Admin.Models

@model FinancialViewModel
@{
    var lenguajes = new List<DefinicionLenguajes> { new DefinicionLenguajes { Name = "Español", lang = "es" }, new DefinicionLenguajes { Name = "Inglés", lang = "en" } };
}

<div class="row page-titles">
    <div class="col-md-12 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Editar Contenidos</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="/Admin">Inicio </a></li>
            <li class="breadcrumb-item active"><a href="/Admin/Finantial">Información financiera</a></li>
            <li class="breadcrumb-item active">Estados financieros</li>
        </ol>
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <div class="col-12 help-content">

        <ul class="nav nav-tabs wow slideInRight" data-wow-offset="300" id="myTab" role="tablist">
            @foreach (var item in lenguajes)
            {
                if (item.lang == Model.Language)
                {
                    <li class="nav-item">
                        <a class="nav-link active" id="spa-tab" data-toggle="tab" href="#langactivo" role="tab" aria-controls="spa" aria-selected="true">@item.Name</a>
                    </li>

                }
                else
                {
                    <li class="nav-item">
                        <a class="nav-link" id="@item.lang-tab" href="/Admin/Finantial/EditFinantial?lang=@item.lang" role="tab" aria-controls="eng" aria-selected="false">@item.Name</a>
                    </li>
                }

            }
            @*
                    <li class="nav-item"> <a class="nav-link active" id="spa-tab" data-toggle="tab" href="#spa" role="tab" aria-controls="spa" aria-selected="true">Español</a> </li>
                <li class="nav-item"> <a class="nav-link" id="eng-tab" data-toggle="tab" href="#eng" role="tab" aria-controls="eng" aria-selected="false">Inglés</a> </li>*@
            <!-- <li class="nav-item"> <a class="nav-link" id="por-tab" data-toggle="tab" href="#por" role="tab" aria-controls="por" aria-selected="false">Portugués</a> </li> -->
        </ul>

        <div class="card wow slideInRight" data-wow-offset="300">
            <!-- <div class="card-block bg-info">
                    <h4 class="text-white card-title">Glosario</h4>
            </div> -->
            <div class="card-block">
                <div class="tab-content" id="myTabContent">
                    <div class="tab-pane show active" id="spa" role="tabpanel" aria-labelledby="spa-tab">
                        @using (@Html.BeginForm("SaveFinantial", "Finantial", FormMethod.Post, new { @class = "form-horizontal form-material", enctype = "multipart/form-data" }))
                        {
                            @Html.HiddenFor(m => m.Language)
                            @Html.HiddenFor(m => m.Tipo)

                            <div class="form-group">
                                @Html.LabelFor(m => m.Title)
                                @Html.EditorFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                                @Html.ValidationMessageFor(m => m.Title)
                            </div>

                            <div class="form-group">
                                <div class="d-flex justify-content-between align-items-center mb-2">
                                    <label class="h6 small d-block text-uppercase mb-0">Cargar imagen de Encabezado</label>
                                </div>
                                <div class="js-focus-state input-group u-form">
                                    <input type="file" name="HeaderImage" id="HeaderImage" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                                    <label for="HeaderImage"><span id="HeaderImageName">@Model.HeaderImageName</span><strong>Seleccionar imagen</strong></label>
                                </div>
                            </div>
                            <dir class="row no-padding">
                                <div class="col-lg-8"></div>
                                <div class="col-lg-4">
                                    <p><a href="/Admin/Financial/template" style="margin: 0;" class="btn btn-success">Descargar plantilla</a></p>
                                </div>
                            </dir>

                            <div class="row no-padding">
                                <div class="col-lg-6">
                                    <div class="form-group">
                                        <label>Seleccionar mes</label>
                                        @Html.DropDownListFor(m => m.Month, Model.MotnthList, new { @class = "form-control form-control-line" })
                                    </div>
                                </div>
                                <div class="col-lg-6">
                                    <div class="form-group">
                                        <label>Seleccionar año</label>
                                        @Html.DropDownListFor(m => m.Year, Model.YearList, new { @class = "form-control form-control-line" })
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="d-flex justify-content-between align-items-center mb-2">
                                    <label class="h6 small d-block text-uppercase mb-0">Importar estados financieros</label>
                                </div>
                                <div class="js-focus-state input-group u-form">
                                    <input type="file" name="FinancialData" id="FinancialData" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                                    <label for="FinancialData"><span id="FinancialDataName">@Model.FinancialDataName</span><strong>Seleccionar archivo</strong></label>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="d-flex justify-content-between align-items-center mb-2">
                                    <label class="h6 small d-block text-uppercase mb-0">Adjuntar memoria y balance (pdf)</label>
                                </div>
                                <div class="js-focus-state input-group u-form">
                                    <input type="file" name="Balance" id="Balance" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                                    <label for="Balance"><span id="BalanceName">@Model.BalanceName</span><strong>Seleccionar archvo</strong></label>
                                </div>
                            </div>

                            <div class="form-group">
                                <button type="submit" class="btn btn-primary u-btn-primary transition-3d-hover">Publicar</button>
                            </div>
                        }
                    </div>
                </div>
            </div>
        </div>
    </div>
@section scripts{
    <script>
        $(function () {
            $('input[type="file"]').change(function () {
                var fileName = $(this).val().match(/[^\\/]*$/)[0];
                var span = $("label[for='" + $(this).attr('id') + "']").find("span");
                span.text(fileName);
            });
        })
    </script>
    }

AdminCaja/Areas/Admin/Views/Finantial/EditNumbers.cshtml
@using AdminCaja.Areas.Admin.Models.Financial
@using AdminCaja.Areas.Admin.Models

@model NumbersViewModel
@{
    var lenguajes = new List<DefinicionLenguajes> { new DefinicionLenguajes { Name = "Español", lang = "es" }, new DefinicionLenguajes { Name = "Inglés", lang = "en" } };
}

<div class="row page-titles">
    <div class="col-md-12 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Editar Contenidos</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="/Admin">Inicio </a></li>
            <li class="breadcrumb-item active"><a href="/Admin/Finantial">Información financiera</a></li>
            <li class="breadcrumb-item active">Caja en cifras</li>
        </ol>
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <div class="col-12 help-content">

        <ul class="nav nav-tabs wow slideInRight" data-wow-offset="300" id="myTab" role="tablist">
            @foreach (var item in lenguajes)
            {
                if (item.lang == Model.Language)
                {
                    <li class="nav-item">
                        <a class="nav-link active" id="spa-tab" data-toggle="tab" href="#langactivo" role="tab" aria-controls="spa" aria-selected="true">@item.Name</a>
                    </li>

                }
                else
                {
                    <li class="nav-item">
                        <a class="nav-link" id="@item.lang-tab" href="/Admin/Finantial/EditFinantial?lang=@item.lang" role="tab" aria-controls="eng" aria-selected="false">@item.Name</a>
                    </li>
                }

            }
        </ul>

        <div class="card wow slideInRight" data-wow-offset="300">
            <!-- <div class="card-block bg-info">
                    <h4 class="text-white card-title">Glosario</h4>
            </div> -->
            <div class="card-block">
                <div class="tab-content" id="myTabContent">
                    <div class="tab-pane show active" id="spa" role="tabpanel" aria-labelledby="spa-tab">
                        @using (@Html.BeginForm("SaveNumbers", "Finantial", FormMethod.Post, new { @class = "form-horizontal form-material", enctype = "multipart/form-data" }))
                        {
                            @Html.HiddenFor(m => m.Language)
                            @Html.HiddenFor(m => m.Tipo)

                            <div class="form-group">
                                @Html.LabelFor(m => m.Title)
                                @Html.EditorFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                                @Html.ValidationMessageFor(m => m.Title)
                            </div>

                            <div class="form-group">
                                <div class="d-flex justify-content-between align-items-center mb-2">
                                    <label class="h6 small d-block text-uppercase mb-0">Cargar imagen de Encabezado</label>
                                </div>
                                <div class="js-focus-state input-group u-form">
                                    <input type="file" name="HeaderImage" id="HeaderImage" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                                    <label for="HeaderImage"><span id="HeaderImageName">@Model.HeaderImageName</span><strong>Seleccionar imagen</strong></label>
                                </div>
                            </div>
                            <dir class="row no-padding">
                                <div class="col-lg-8"></div>
                                <div class="col-lg-4">
                                    <p><a href="/Admin/Financial/template" style="margin: 0;" class="btn btn-success">Descargar plantilla</a></p>
                                </div>
                            </dir>

                            <div class="form-group">
                                <label>Seleccionar período</label>
                                @Html.DropDownListFor(m => m.SelectedPeriod, Model.QuarterList, new { @class = "form-control form-control-line" })
                            </div>
                            <div class="form-group">
                                <div class="d-flex justify-content-between align-items-center mb-2">
                                    <label class="h6 small d-block text-uppercase mb-0">Importar estados financieros</label>
                                </div>
                                <div class="js-focus-state input-group u-form">
                                    <input type="file" name="FinancialData" id="FinancialData" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                                    <label for="FinancialData"><span id="FinancialDataName">@Model.FinancialDataName</span><strong>Seleccionar archivo</strong></label>
                                </div>
                            </div>

                            <div class="form-group">
                                <button type="submit" class="btn btn-primary u-btn-primary transition-3d-hover">Publicar</button>
                            </div>
                        }
                    </div>
                </div>
            </div>
        </div>
    </div>

    @section scripts{
        <script>
            $(function () {
                $('input[type="file"]').change(function () {
                    var fileName = $(this).val().match(/[^\\/]*$/)[0];
                    var span = $("label[for='" + $(this).attr('id') + "']").find("span");
                    span.text(fileName);
                });
            })
        </script>
    }

AdminCaja/Areas/Admin/Views/Finantial/Index.cshtml
<!-- ============================================================== -->
<!-- Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<div class="row page-titles">
    <div class="col-md-5 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Secciones</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="index.html">Inicio </a></li>
            <li class="breadcrumb-item"><a href="secciones.html">Secciones</a></li>
            <li class="breadcrumb-item active">Caja de Valores</li>
        </ol>
        <!-- <ol class="breadcrumb">
          <li class="breadcrumb-item" style="margin-top: 10px;"><a href="#" class="btn btn-export" >Ver todas</a></li>
        </ol> -->
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <!-- column -->
    <div class="col-lg-12 help-content">
        <div id="" class="card wow slideInRight" data-wow-delay=".3s" data-wow-offset="300">
            <div class="perfil-head"></div>
            <div class="card-block">
                <div class="table-responsive">

                    <table>
                        <thead>
                            <tr>
                                <th scope="col">ID</th>
                                <th scope="col">Título</th>
                                <th scope="col">Acciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td data-label="Título">1</td>
                                <td data-label="Título">Estados financieros</td>
                                <td class="comandos" data-label="Acciones"><a href="/Admin/Finantial/EditFinantial" class="btn btn-export">Editar</a></td>
                            </tr>
                            <tr>
                                <td data-label="Título">2</td>
                                <td data-label="Título">Caja en cifras</td>
                                <td class="comandos" data-label="Acciones">
                                    <a href="/Admin/Finantial/EditNumbers" class="btn btn-export">Editar</a> 
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- ============================================================== -->
<!-- End PAge Content -->
<!-- ============================================================== -->